function mult(AFileName, BFileName)
% read in a compressed matrix
% multiply it by a vector
% print the result

C0FileName = 'Data/outC0';
C1FileName = 'Data/outC1';
C2FileName = 'Data/outC2';
C3FileName = 'Data/outC3';
C4FileName = 'Data/outC4';
C5FileName = 'Data/outC5';
C8FileName = 'Data/outC8';
C9FileName = 'Data/outC9';
C12FileName = 'Data/outC12';
C13FileName = 'Data/outC13';

BFileName2 = 'Data/B30rowmaj';

B12FileName = 'Data/outB12';
B13FileName = 'Data/outB13';


[A, rows, cols, entries] = mmread(AFileName); 

% read our B matrix
BFile = fopen(BFileName,'r');

% read the first line - dimensions
fscanf(BFile, '%d',1);
fscanf(BFile, '%d',1);

B = fscanf(BFile,'%f',[30,30]);

% read our Browmaj matrix
BFile2 = fopen(BFileName2,'r');

% read the first line
fscanf(BFile2, '%d',1);
fscanf(BFile2, '%d',1);
Browmaj = fscanf(BFile2,'%f',[30,30]);


format long
%disp('A')
%disp(A)
%disp('B')
%disp(B)


% **************************** Case 0

% Case 0: alpha == 1.0, beta = 0.0, zero base, no transpose,
% column-major


% read the matrix generated by the C program

C0File = fopen(C0FileName, 'r');
M0 = fscanf(C0File,'%d',1);
N0 = fscanf(C0File,'%d',1);
C0 = fscanf(C0File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;
C = alpha * A * B;

disp('Case 0:')
%disp('C')
%disp(C)
%disp('C0')
%disp(C0)
disp('norm(C-C0)')
disp(norm(C-C0)/((norm(C) + norm(C0)/2)))


% **************************** Case 1

% Case 1: alpha == 1.0, beta = 0.0, one base, no transpose,
% column-major


% read the matrix generated by the C program

C1File = fopen(C1FileName,'r');
fscanf(C1File,'%d',1);
fscanf(C1File,'%d',1);
C1 = fscanf(C1File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;
C = alpha * A * B;

disp('Case 1:')
%disp('C')
%disp(C)
%disp('C1')
%disp(C1)
disp('norm(C-C1)')
disp(norm(C-C1)/((norm(C) + norm(C1)/2)))


% **************************** Case 2

% Case 2:  alpha == 0.0 && beta != 0.0


% read the matrix generated by the C program
C2File = fopen(C2FileName,'r');
fscanf(C2File,'%d',1);
fscanf(C2File,'%d',1);
C2 = fscanf(C2File,'%f',[30,30]);

alpha = 0.0;
beta = -3.75;

origC = [ones(30,30)];
C = alpha * A * B + beta * origC;

disp('Case 2:')
%disp('C')
%disp(C)
%disp('C2')
%disp(C2)
disp('norm(C-C2)')
disp(norm(C-C2)/((norm(C) + norm(C2)/2)))



% **************************** Case 3

% Case 3:	transpose


% read the matrix generated by the C program
C3File = fopen(C3FileName,'r');
fscanf(C3File,'%d',1);
fscanf(C3File,'%d',1);
C3 = fscanf(C3File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;

C = alpha * A' * B;

disp('Case 3:')
%disp('C')
%disp(C)
%disp('C3')
%disp(C3)
disp('norm(C-C3)')
disp(norm(C-C3)/((norm(C) + norm(C3)/2)))



% ***************** Case 4 & Case 6

% Case 4 & Case 6: ColMajor && beta == 0.0 
% && alpha == 1.0



% read the matrix generated by the C program
C4File = fopen(C4FileName,'r');
fscanf(C4File,'%d',1);
fscanf(C4File,'%d',1);
C4 = fscanf(C4File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;
 
C = alpha * A * B;

disp('Case 4 (& Case 6):')
%disp('C')
%disp(C)
%disp('C4')
%disp(C4)
disp('norm(C-C4)')
disp(norm(C-C4)/((norm(C) + norm(C4)/2)))


% ***************** Case 5 & Case 7

% Case 5 & Case 7: ColMajor && beta != 0.0 && alpha != 1.0


% read the matrix generated by the C program
C5File = fopen(C5FileName,'r');
fscanf(C5File,'%d',1);
fscanf(C5File,'%d',1);
C5 = fscanf(C5File,'%f',[30,30]);

alpha = 2.25;
beta = -3.75;

origC = [ones(30,30)];
C = alpha * A * B + beta * origC;

disp('Case 5 (& Case 7):')
%disp('C')
%disp(C)
%disp('C5')
%disp(C5)
disp('norm(C-C5)')
disp(norm(C-C5)/((norm(C) + norm(C5)/2)))



% ***************** Case 8 & Case 10

% Case 8 and Case 10:	RowMajor && beta == 0.0 && alpha == 1.0


% read the matrix generated by the C program
C8File = fopen(C8FileName,'r');
fscanf(C8File,'%d',1);
fscanf(C8File,'%d',1);
C8 = fscanf(C8File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;

C = alpha * A * Browmaj;

disp('Case 8 (& Case 10):')
%disp('C')
%disp(C)
%disp('C8')
%disp(C8)
disp('norm(C-C8)')
disp(norm(C-C8)/((norm(C) + norm(C8)/2)))


% ***************** Case 9 & Case 11

% Case 9 and Case 11:	RowMajor && beta != 0 && alpha != 1.0


% read the matrix generated by the C program
C9File = fopen(C9FileName,'r');
fscanf(C9File,'%d',1);
fscanf(C9File,'%d',1);
C9 = fscanf(C9File,'%f',[30,30]);

alpha = 2.25;
beta = 0.0;
%beta = -3.75;

origC = [ones(30,30)];
C = alpha * A * Browmaj + beta * origC;

disp('Case 9 (& Case 11):')
%disp('C')
%disp(C)
%disp('C9')
%disp(C9)
disp('norm(C-C9)')
disp(norm(C-C9)/((norm(C) + norm(C9)/2)))



% ***************** Case 12 ***********

% Case 12  Column major and B, C submatrices


% read the matrix generated by the C program
C12File = fopen(C12FileName,'r');
fscanf(C12File,'%d',1);
fscanf(C12File,'%d',1);
C12 = fscanf(C12File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;

% read our B12 matrix
B12File = fopen(B12FileName,'r');
fscanf(B12File,'%d',1);
fscanf(B12File,'%d',1);
B12 = fscanf(B12File,'%f',[30,30]);

C = alpha * A * B12;

disp('Case 12:')
%disp('B')
%disp(B12)
%disp('C')
%disp(C)
%disp('C12')
%disp(C12)
disp('norm(C-C12)')
disp(norm(C-C12)/((norm(C) + norm(C12)/2)))



% ***************** Case 13 ***********

% Case 13  Column major and B, C submatrices


% read the matrix generated by the C program
C13File = fopen(C13FileName,'r');
fscanf(C13File,'%d',1);
fscanf(C13File,'%d',1);
C13 = fscanf(C13File,'%f',[30,30]);

alpha = 1.0;
beta = 0.0;

% read our B13 matrix
B13File = fopen(B13FileName,'r');
fscanf(B13File,'%d',1);
fscanf(B13File,'%d',1);
B13 = fscanf(B13File,'%f',[30,30]);

% use B13 transpose, since it is used row-major in C
C = alpha * A * B13';

disp('Case 13:')
%disp('B')
%disp(B13)
%disp('C')
%disp(C)
%disp('C13')
%disp(C13)
disp('norm(C-C13)')
disp(norm(C-C13)/((norm(C) + norm(C13)/2)))
