/* just test csrmm.c */

#include <stdio.h>
#include ""
#include "spblas_i.h"
#include "c_blas.h"

/* initialize a matrix */
void ArraySetToValue(double *A, int ldA, int outer , int inner, double value)
{
  double *p, *pend, *t, *tend;

  pend = A + outer*ldA;
  for (p=A; p<pend; p+=ldA)  {
    tend = p+inner;
    for (t=p; t<tend; *t++ = value);
  }
}

/* print a dense matrix */
void ArrayPrint(double *A, int ldA, int outer , int inner, FILE *output)
{
  double *p, *pend, *t, *tend;
  
  fprintf(output, "%d %d\n", outer, inner);

  pend = A + outer*ldA;

  for (p=A; p<pend; p+=ldA) {
    tend = p+inner;
    for (t=p; t<tend; t++) 
      fprintf(output,"%f ",*t);
    fprintf(output,"\n");
  }
}

int main(int argc, char *argv[])
{
	DCSC A = NULL;

	int M = 5;
	int N = 5;
	int nz = 15;
	double val[] = {1.1, 2.1, 2.2, 3.1, 3.2, 3.3, 4.1, 4.2, 4.3, 4.4, 5.1, 5.2, 5.3, 5.4, 5.5};
	int indx[]  =  { 0,   0,   1,   0,   1,   2,   0,   1,   2,   3,   0  , 1 ,  2,   3,   4};
	int pntrb[] =  { 0,  1,  3,  6,  10};
	int pntre[] =  { 1,  3,  6,  10, 15};


	int prop = sparse_blas_zero_base;
	
	double B[5][5] = {{1.0, 1.0, 1.0, 1.0, 1.0},
			  {1.0, 1.0, 1.0, 1.0, 1.0},
			  {1.0, 1.0, 1.0, 1.0, 1.0},
			  {1.0, 1.0, 1.0, 1.0, 1.0},
			  {1.0, 1.0, 1.0, 1.0, 1.0}};

	int ldb = 5;
	double alpha = 1.0;
	int k = 5;

	int order = blas_colmajor;
	int transpose = blas_no_trans;

	A = create_DCSC(M, N, nz, val, indx, pntrb, pntre, prop); 
	DCSC_print(A);
	printf("\n\n");

	printf("\nB:\n");
	ArrayPrint(B, ldb, k, N, stdout);


	c_dussmUD_CSC( order,  transpose, alpha,  A,  k, B, ldb);

	printf("\nB:\n");
	ArrayPrint(B, ldb, k, N, stdout);
	
	return 0;
}



