#ifndef DBSCMMI_H
#define DBSCMMI_H


void c_dusmv_BSC(enum blas_trans_type T, const double alpha, 
		DBSC A, const double *x,
		int incx, const double beta, double *y, int incy);



void c_dusmm_BSC(enum blas_order_type order, 
		enum blas_trans_type T, int k,
		double alpha, DBSC A, const double *B,
		int ldB, double beta, double *C, int ldC);

void dbscmm(int nb, 
		enum sparse_blas_base_type base,
		enum blas_trans_type transblock, 
		enum blas_order_type order, int Mnb, int Nnb, int K, double alpha, 
		const int *pntrb, const int *pntre, const double *val,
		const int *indx, const double *B, int ldB, double beta,
		double *C, int ldC);

void dbscmm_row(int nb, enum blas_trans_type transblock, int Mnb, 
			int K, const int *pntrb, const int *pntre, 
			const double *val, const int *indx, double alpha, 
			const double *B, int ldB, double beta, double *C, int ldC);


void dbscmm_col(int nb, enum blas_trans_type transblock, int Mnb, int K, 
			const int *pntrb, const int *pntre, 
			const double *val, const int *indx, double alpha, 
			const double *B, int ldB, double beta, double *C, int ldC);

#endif

