#ifndef DCSCMMI_H
#define DCSCMMI_H



void c_dusmv_CSC(enum blas_trans_type T, const double alpha, 
		SPBLASI_double_CSC A, const double *x,
		int incx, const double beta, double *y, int incy);


void c_dusmm_CSC(enum blas_order_type order, enum blas_trans_type T, int k,
		double alpha, SPBLASI_double_CSC A, const double *B,
		int ldB, double beta, double *C, int ldC);

void dcscmm(int Aprop, enum blas_order_type order, 
		int M, int N, int K, double alpha, 
		const int *pntrb, const int *pntre, const double *val,
		const int *indx, const double *B, int ldB, double beta,
		double *C, int ldC);

void dcscmm_row(int M, int K, const int *pntrb, const int *pntre, 
			const double *val, const int *indx, double alpha, 
			const double *B, int ldB, double beta, double *C, int ldC);


/* C = alpha * A*B + beta*y;  A is compressed-row, B&C are col-major  */   

void dcscmm_col(int M, int K, const int *pntrb, const int *pntre, 
			const double *val, const int *indx, double alpha, 
			const double *B, int ldB, double beta, double *C, int ldC);



#endif

