function matrixMult(AFileName, BFileName, BFileName2)
% read in a compressed matrix
% multiply it by a vector
% print the result

C0FileName = 'Data/outC0';
C1FileName = 'Data/outC1';

[A, rows, cols, entries] = mmread(AFileName); 

% read our B matrix
BFile = fopen(BFileName,'r');

% read the first line - dimensions
height = fscanf(BFile, '%d',1);
width = fscanf(BFile, '%d',1);

B = fscanf(BFile,'%f',[height,width]);

% read our B1 matrix
BFile2 = fopen(BFileName2,'r');

% read the first line
fscanf(BFile2, '%d',height);
fscanf(BFile2, '%d',width);
B1 = fscanf(BFile2,'%f',[height,width]);


format long
%disp('A')
%disp(A)
%disp('B')
%disp(B)


% **************************** Case 0

% Case 0: alpha == 1.0, beta = 0.0, zero base, no transpose,
% column-major


% read the matrix generated by the C program

C0File = fopen(C0FileName, 'r');
height = fscanf(C0File,'%d',1);
width = fscanf(C0File,'%d',1);
C0 = fscanf(C0File,'%f',[height,width]);

alpha = 1.0;
beta = 0.0;
C = alpha * A * B;

disp('Case 0:')
disp('C')
disp(C)
%disp('C0')
%disp(C0)
disp('norm(C-C0)')
disp(norm(C-C0)/((norm(C) + norm(C0)/2)))


% **************************** Case 1

% Case 1: alpha == 1.0, beta = 0.0, one base, no transpose,
% column-major


% read the matrix generated by the C program

%C1File = fopen(C1FileName,'r');
%height = fscanf(C1File,'%d',1);
%width = fscanf(C1File,'%d',1);
%C1 = fscanf(C1File,'%f',[height,width]);

%alpha = 1.0;
%beta = 0.0;
%C = alpha * A * B1;

%disp('Case 1:')
%disp('C')
%disp(C)
%disp('C1')
%disp(C1)
%disp('norm(C-C1)')
%disp(norm(C-C1)/((norm(C) + norm(C1)/2)))


