#include <stdio.h>
#include <string.h>

/* print a dense matrix */
void ArrayPrint(double *A, int ldA, int outer , int inner, FILE *output)
{
  double *p, *pend, *t, *tend;
  
  fprintf(output, "%d %d\n", outer, inner);

  pend = A + outer*ldA;

  for (p=A; p<pend; p+=ldA) {
    tend = p+inner;
    for (t=p; t<tend; t++) 
      fprintf(output,"%f ",*t);
    fprintf(output,"\n");
  }
}

void CSR_MatTriangSlvLD_CAB_double(
                 const int m, const int n,  
                   const double *val, 
                 const int *indx, const int *pntrb, const int *pntre, 
                 const double *b, const int ldb,  
                 double *c, const int ldc,  const int ind_base)
{
  int i, j, jb, je, index;
  double *pc=c;
  int l;                                              
  double z; 
  double valtmp;
  val-=ind_base;
  indx-=ind_base;

  c-=ind_base;
  for (l=0;l!=n;l++) {                                
    pc=c+ind_base;

    for (i=0;i!=m;i++) {
      z = 0;
      jb = pntrb[i];
      je = pntre[i];
      for (j=jb;j<je;j++) {
        index = indx[j];
        if ( index == i+ind_base ) {
          valtmp = val[j];
        } else {
          z += c[index] * val[j];
        }
      }
      pc[i] = (b[i] - z) / valtmp;
    }

    c += ldc; b += ldb;                               
  }                                                   
}


int main(int argc, char *argv[]) {

  double val[] = {1.1, 0, 2.1, 2.2};
  int indx[]  =  { 0,   1,   0,  1};
  int pntrb[] =  { 0,   2 };
  int pntre[] =  { 2,   4 };

  int m = 2;
  int n = 2;

  double B[] = { 2, 2, 2, 2 };
  int ldb = 2;

  double C[] = { 0, 0, 0, 0};
  int ldc = 2;
  
  int ind_base = 0;

  /*

  CSR_MatTriangSlvLD_CAB_double(m ,n ,val ,indx ,pntrb ,pntre ,B ,ldb ,C ,ldc ,ind_base);

  ArrayPrint(C, ldb, m, m, stdout);
  */


  /*
  CSR_MatTriangSlvLD_CAB_double(m ,n ,val ,indx ,pntrb ,pntre ,B ,ldb ,C ,ldc ,ind_base);

  ArrayPrint(C, ldb, m, m, stdout);
  */
}


