function triSolve(AFileName)
% read in a compressed matrix
% multiply it by a vector
% print the result

B0FileName = 'UU_Data/outB0';
B1FileName = 'UU_Data/outB1';
B2FileName = 'UU_Data/outB2';
B3FileName = 'UU_Data/outB3';
B4FileName = 'UU_Data/outB4';
B5FileName = 'UU_Data/outB5';

BFileName = 'UU_Data/B30random';

% read the A matrix
[A, rows, cols, entries] = mmread(AFileName); 

% read our B matrix
BFile = fopen(BFileName,'r');

% read the first line - dimensions
fscanf(BFile, '%d',1);
fscanf(BFile, '%d',1);

B = fscanf(BFile,'%f',[30,30]);


format long
disp('A')
disp(full(A))


% **************************** Case 0

% Case 0: alpha == 1.0, zero base, no transpose, Bones = {1 1 1...1}

% read the matrix generated by the C program

B0File = fopen(B0FileName, 'r');
M0 = fscanf(B0File,'%d',1);
N0 = fscanf(B0File,'%d',1);
B0 = fscanf(B0File,'%f',[30,30]);

alpha = 1.0;

Bones = ones(30,30);
B0ml = alpha * inv(A) * Bones;


disp('Case 0:')
disp('Bml')
disp(B0ml)
disp('B0')
disp(B0)
disp('norm(B0ml-B0)')
disp(norm(B0ml-B0)/cols)


% **************************** Case 1


% Case 1:	base_one, col_major

% read the matrix generated by the C program
B1File = fopen(B1FileName,'r');
fscanf(B1File,'%d',1);
fscanf(B1File,'%d',1);
B1 = fscanf(B1File,'%f',[30,30]);

alpha = 1.0;


B1ml = alpha * inv(A) * B;

disp('Case 1:')
%disp('B1ml')
%disp(B1ml)
%disp('B1')
%disp(B1)
disp('norm(B1ml-B1)')
disp(norm(B1ml-B1)/cols)

% **************************** Case 2

% Case 2:	base_one, row_major

% read the matrix generated by the C program
B2File = fopen(B2FileName,'r');
fscanf(B2File,'%d',1);
fscanf(B2File,'%d',1);
B2 = fscanf(B2File,'%f',[30,30]);

alpha = 1.0;


B2ml = alpha * inv(A) * B;

disp('Case 2:')
%disp('B2ml')
%disp(B2ml)
%disp('B2')
%disp(B2)
disp('norm(B2ml-B2)')
disp(norm(B2ml-B2)/cols)


% **************************** Case 3

% Case 3: alpha == 1.0,  transpose,
% column-major


% read the matrix generated by the C program

B3File = fopen(B3FileName,'r');
fscanf(B3File,'%d',1);
fscanf(B3File,'%d',1);
B3 = fscanf(B3File,'%f',[30,30]);

alpha = 1.0;

B3ml = alpha * inv(A') * B;

disp('Case 3:')
%disp('B3ml')
%disp(B3ml)
%disp('B3')
%disp(B3)
disp('norm(B3ml-B3)')
disp(norm(B3ml-B3)/cols)




% ***************** Case 4 


% Case 4 - submatrix column major

% read the matrix generated by the C program
B4File = fopen(B4FileName,'r');
fscanf(B4File,'%d',1);
fscanf(B4File,'%d',1);
B4 = fscanf(B4File,'%f',[30,30]);


alpha = 1.0;

% just use the dense B
B4ml = alpha * inv(A) * B;

disp('Case 4:');
%disp('B4ml')
%disp(B4ml)
%disp('B4')
%disp(B4)


disp('norm(B4ml-B4)')
disp(norm(B4ml-B4)/cols)


% ***************** Case 5 

% Case 5 - submatrix row major

% read the matrix generated by the C program
B5File = fopen(B5FileName,'r');
fscanf(B5File,'%d',1);
fscanf(B5File,'%d',1);
B5 = fscanf(B5File,'%f',[30,30]);


alpha = 1.0;

% just use the dense B
B5ml = alpha * inv(A) * B;

disp('Case 5:');
%disp('B5ml')
%disp(B5ml)
%disp('B5')
%disp(B5)


disp('norm(B5ml-B5)')
disp(norm(B5ml-B5)/cols)


