function triSolve(AFileName)
% read in a compressed matrix
% multiply it by a vector
% print the result

X0FileName = 'UU_Data/outX0';
X1FileName = 'UU_Data/outX1';
X2FileName = 'UU_Data/outX2';
X3FileName = 'UU_Data/outX3';
X4FileName = 'UU_Data/outX4';
X5FileName = 'UU_Data/outX5';
X6FileName = 'UU_Data/outX6';

XFileName = 'UU_Data/X30random';

% read the A matrix
[A, rows, cols, entries] = mmread(AFileName); 

% read our X matrix
XFile = fopen(XFileName,'r');

% read the first line - dimensions
fscanf(XFile, '%d',1);
fscanf(XFile, '%d',1);

X = fscanf(XFile,'%f',[30,1]);


format long
disp('A')
disp(full(A))


% **************************** Case 0

% Case 0: alpha == 1.0, zero base, no transpose, Xones = {1 1 1...1}

% read the matrix generated by the C program

X0File = fopen(X0FileName, 'r');
M0 = fscanf(X0File,'%d',1);
N0 = fscanf(X0File,'%d',1);
X0 = fscanf(X0File,'%f',[30,1]);

alpha = 1.0;

Xones = ones(30,1);
X0ml = alpha * inv(A) * Xones;


disp('Case 0:')
%disp('Xml')
%disp(X0ml)
%disp('X0')
%disp(X0)
disp('norm(X0ml-X0)')
disp(norm(X0ml-X0)/cols)


% **************************** Case 1

% Case 1: alpha == 1.0,  transpose,
% column-major


% read the matrix generated by the C program

X1File = fopen(X1FileName,'r');
fscanf(X1File,'%d',1);
fscanf(X1File,'%d',1);
X1 = fscanf(X1File,'%f',[30,1]);

alpha = 1.0;

X1ml = alpha * inv(A') * X;

disp('Case 1:')
%disp('X1ml')
%disp(X1ml)
%disp('X1')
%disp(X1)
disp('norm(X1ml-X1)')
disp(norm(X1ml-X1)/cols)


% **************************** Case 2

% Case 2:  alpha == 0.0

% read the matrix generated by the C program
X2File = fopen(X2FileName,'r');
fscanf(X2File,'%d',1);
fscanf(X2File,'%d',1);
X2 = fscanf(X2File,'%f',[30,30]);

alpha = 0.0;

X2ml = alpha * inv(A) * X;

disp('Case 2:')
%disp('X2ml')
%disp(X2ml)
%disp('X2')
%disp(X2)
disp('norm(X2ml-X2)')

% to avoid divide by zero
disp(norm(X2ml - X2));
%disp(norm(X2ml-X2)/cols)



% **************************** Case 3

% Case 3:	base_one

% read the matrix generated by the C program
X3File = fopen(X3FileName,'r');
fscanf(X3File,'%d',1);
fscanf(X3File,'%d',1);
X3 = fscanf(X3File,'%f',[30,30]);

alpha = 1.0;


X3ml = alpha * inv(A) * X;

disp('Case 3:')
%disp('X3ml')
%disp(X3ml)
%disp('X3')
%disp(X3)
disp('norm(X3ml-X3)')
disp(norm(X3ml-X3)/cols)


% ***************** Case 4 

% Case 4
% alpha == 1.0



% read the matrix generated by the C program
X4File = fopen(X4FileName,'r');
fscanf(X4File,'%d',1);
fscanf(X4File,'%d',1);
X4 = fscanf(X4File,'%f',[30,30]);

alpha = 1.0;

X4ml = alpha * inv(A) * X;

disp('Case 4:')
%disp('X4ml')
%disp(X4ml)
%disp('X4')
%disp(X4)
disp('norm(X4ml-X4)')
disp(norm(X4ml-X4)/cols)


% ***************** Case 5 

% Case 5 
% alpha != 1.0

% read the matrix generated by the C program
X5File = fopen(X5FileName,'r');
fscanf(X5File,'%d',1);
fscanf(X5File,'%d',1);
X5 = fscanf(X5File,'%f',[30,1]);

alpha = 2.25;
X5ml = alpha * inv(A) * X;


disp('Case 5:');
%disp('X5ml')
%disp(X5ml)
%disp('X5')
%disp(X5)
disp('norm(X5ml-X5)')
disp(norm(X5ml-X5)/cols)



% ***************** Case 6

% Case 6
% incx = 2 (only used in the C program)

% read the matrix generated by the C program
X6File = fopen(X6FileName,'r');
fscanf(X6File,'%d',1);
fscanf(X6File,'%d',1);
X6 = fscanf(X6File,'%f',[60,1]);


% get rid of 0 entries

for k = 60:-2:2
   X6(k,:) = [];
end

alpha = 1.0;

% just use the dense X
X6ml = alpha * inv(A) * X;

disp('Case 6:');
disp('X6ml')
disp(X6ml)
disp('X6')
disp(X6)


disp('norm(X6ml-X6)')
disp(norm(X6ml-X6)/cols)


