#include <stdio.h>
#include ""
#include "spblas_i.h"
#include "c_blas.h"
#include "mmio.h"

/* print a dense matrix */
void ArrayPrint(double *A, int ldA, int outer , int inner, FILE *output)
{
  double *p, *pend, *t, *tend;
  
  fprintf(output, "%d %d\n", outer, inner);

  pend = A + outer*ldA;

  for (p=A; p<pend; p+=ldA) {
    tend = p+inner;
    for (t=p; t<tend; t++) 
      fprintf(output,"%f ",*t);
    fprintf(output,"\n");
  }
}

int main(int argc, char *argv[]) {


  DCSR A = NULL;

  /*
  double val[] = {1.1, 2.1, 2.2};
  int indx[]  =  { 0,   0,  1};
  int pntrb[] =  { 0,   1 };
  int pntre[] =  { 1,   3 };
  int nz = 3;

  int m = 2;
  int n = 2;

  double y[] = { 2, 2};
  int incy= 1;

  double x[] = { 0, 0};
  int incx = 1;
  
  int prop = sparse_blas_zero_base;
  int transpose = blas_no_trans;

  double alpha = 1.0;
  
  int ind_base = 0;
*/


  double val[] = {1.1, 1.2, 1.3, 1.4, 1.5, 2.2, 2.3, 2.4, 2.5, 3.3, 3.4, 3.5, 4.4, 4.5, 5.5};
  int indx[]  =  { 0,   1,   2,   3,   4,   1,  2  , 3 ,   4,   2,   3,   4,   3,   4,   4};
  int pntrb[] =  { 0,   5,   9,   12,  14};
  int pntre[] =  { 5,   9,   12,  14,  15};
  int nz = 15;

  int m = 5;
  int n = 5;

  double x[] = { 12.1, 123.3, 55.3, 324.354, 567.322};
  int incx = 1;
  
  int prop = sparse_blas_zero_base;
  int transpose = blas_no_trans;

  double alpha = 2.0;
  
  int ind_base = 0;

 
  A = create_DCSR(m, n,  nz, val, indx, 
		pntrb, pntre, prop);

  DCSR_print(A);
  
  printf("\n\n");
  ArrayPrint(x, m, 1, m, stdout);
  
  printf("\n\n");
  c_dussvUD_CSR( transpose, alpha, A, x, incx );

  printf("\n\n");
  ArrayPrint(x, m, 1, m, stdout);

}







