#ifndef NULL
#define NULL 0
#endif
#define DCOO SPBLASI_double_COO

typedef struct
{
	int M_, N_, nz_;
	int prop_;
	double *val_;
	int *i_;
	int *j_;
	int reclaim_space; 		/* boolean, true if mallocs own val, i, j */	
} *DCOO, DCOO_struct;


DCOO create_DCOO( int M, int N, int nz, double *val,
	int *indx, int *jndx, int properties)

{
	DCOO A = (DCOO) malloc(sizeof(DCOO_struct));

	if (A == NULL) return NULL;

	A->val_ = val;
	A->i_ = indx;
	A->j_ = jndx;
	A->M_ = M;
	A->N_ = N;
	A->nz_ = nz;
	A->prop_ = properties;
	A->reclaim_space = 0;

	return A;
}

DCOO create_DCOO_copy( int M, int N, int nz, double *val,
	int *indx, int *jndx, int properties)

{
	DCOO A = NULL;
	int i;

	if ((A = (DCOO) malloc(sizeof(DCOO_struct))) == NULL) return NULL;
	if ((A->val_ = (double*) malloc(sizeof(double)*nz)) == NULL) return NULL;
	if ((A->i_ = (int*) malloc(sizeof(int)*nz)) == NULL) return NULL;
	if ((A->j_ = (int*) malloc(sizeof(int)*nz)) == NULL) return NULL;

	/* copy over values */

	for (i=0; i<nz; i++)
	{
		A->val_[i] = val[i];
		A->i_[i] = indx[i];
		A->j_[i] = jndx[i];
	}
	A->M_ = M;
	A->N_ = N;
	A->nz_ = nz;
	A->prop_ = properties;
	A->reclaim_space = 1;

	return A;
}


void destroy_DCOO( DCOO A)
{
	if (A==NULL) return;

	if (A->reclaim_space)
	{
		free(A->val_);
		free(A->i_);
		free(A->j_);
	}
	
	free(A);
}


