#include <malloc.h>
#include "spblas.h"
#include "spblas_i.h"

/* create a new (0-based) compressed-column sparse matrix from a 
		coordinate sparse matirx */

DCSR DCOO_2_DCSR(DCOO A)
{

	int i=0;
	int M = A->M_;
	int N = A->N_;
	int *I = A->i_;
	int *J = A->j_;
	double *val = A->val_;
	int nz = A->nz_;
	int properties = A->prop_;
	int index = 0;

					 /* need to do something here with index-base*/
	int index_base = A->prop_ || blas_zero_base;

	/* components for CSR routine */

		
	double *csr_val = NULL;
	int *csr_pntrb = NULL;
	int *csr_j = NULL;
	int *tally = NULL;


	csr_val = (double *) malloc(nz * sizeof(double));
	csr_pntrb = (int *) malloc( (M+1) * sizeof (int));
	csr_j = (int *) malloc(nz*sizeof(int));
	tally = (int *) malloc( (M) * sizeof (int));

	

	/* 1st pass: find out how many elements in each row */

	for (i=0; i<nz; i++)
		tally[I[i] - index_base]++;


	/* convert tally[] into (0-based) row pointer by accumulating
		row-lengths.  tally[i] now points to the begining or row i  */

	for (i=1;i<M; i++)
		tally[i] += tally[i-1];


	/* copy these values into pntrb[]; (we will be using the values
		of tally[] as place-markers, which change as we fill up the
		CSR matrix). */

	csr_pntrb[0]=0;
	for (i=0; i<M; i++)
		csr_pntrb[i+1] = tally[i];

	/* copy back original row-starts into tally */
	for (i=0; i<M; i++)
		tally[i] = csr_pntrb[i];

	/* 2nd pass: now go through and fill-in CSR format */

	for (i=0; i<nz; i++)
	{
		index = tally[I[i]]++;
		csr_val[index] = val[i];
		csr_j[index] = J[i];
	}

	free(tally);
	return create_DCSR(M, N, nz, csr_val, csr_j, csr_pntrb, csr_pntrb+1, 
		properties);

}
		



