/**
  
  @author Galen J. Wilkerson
  
  */
import java.io.*;

public class TestMult {
  
  public TestMult() {

  }
  
  
  
  /** 
    test driver
    */
  public static void main(String args[]) {
    
    double alpha, beta;
    int M;
    int N;
    int nz;

    int transpose = Jblas.NoTrans;
    
    // the compressed row matrix for testing
    DCSC CSCA;

    // initialize matrix A
    DCOO A = new DCOO();
    
    try {
      A.read("Data/pores_1.mtx");
    }
    catch (IOException e) {
      e.printStackTrace();
    }
     
    M = A.getNumRows();
    N = A.getNumCols();
    nz = A.getNumNonZero();

    

    // convert the DCOO object A into the DCSC object CSCA
    CSCA = new DCSC(A);

    System.out.println("DCOO A:");
    
    A.print();

    System.out.println("\nDCSC CSCA:");

    CSCA.print();



    // initialize vector x
    double x[];
    int incx = 1;

    try {
      x = Dense.readVector("Data/x");
    }
    catch (IOException e) {
      e.printStackTrace();
      return;
    }
     

    double y[] = new double[M];
    int incy = 1;

    // initialize vector x1
    double x1[];
    int incx1 = 2;

    try {
      x1 = Dense.readVector("Data/x1");
    }
    catch (IOException e) {
      e.printStackTrace();
      return;
    }
    
    double y1[] = new double[M];
    int incy1 = 1;
    

    /****************************
      Case 0
      transpose = no trans
      incx = 1
      incy = 1

      ****************************/


    alpha = 1.0;
    beta = 0.0;

    // zero-out y
    Dense.arraySetToValue(y,incy,0.0);

    CSCA.dusmv(transpose, alpha, x, incx, beta, y, incy);

    try {
      Dense.save(y, incy,"Data/y0");
    }
    catch(IOException e) {
      e.printStackTrace();
    }

    
    /****************************
      Case 1
      transpose = trans
      incx1 = 2
      incy1 = 1
      
      ****************************/

    // init y1 to all 1.0
    Dense.arraySetToValue(y1,incy1,0.0);

    transpose = Jblas.Trans;
    CSCA.dusmv(transpose, alpha, x1, incx1, beta, y1, incy1);

    try {
      Dense.save(y1, incy1,"Data/y1");
    }
    catch(IOException e) {
      e.printStackTrace();
    }
  }
}
