function mult(AFileName, BFileName)
% read in a compressed matrix
% multiply it by a vector
% print the result

C0FileName = 'Data/outC0';
C2FileName = 'Data/outC2';
C3FileName = 'Data/outC3';
C8FileName = 'Data/outC8';
C9FileName = 'Data/outC9';
C13FileName = 'Data/outC13';

BFileName2 = 'Data/B30rowmaj';

B12FileName = 'Data/outB12';
B13FileName = 'Data/outB13';


[A, rows, cols, entries] = mmread(AFileName); 

% read our B matrix
BFile = fopen(BFileName,'r');

% read the first line - dimensions
fscanf(BFile, '%d',1);
fscanf(BFile, '%d',1);

B = fscanf(BFile,'%f',[30,30]);

% read our Browmaj matrix
BFile2 = fopen(BFileName2,'r');

% read the first line
fscanf(BFile2, '%d',1);
fscanf(BFile2, '%d',1);
Browmaj = fscanf(BFile2,'%f',[30,30]);


format long
%disp('A')
%disp(A)
%disp('B')
%disp(B)


% **************************** Case 0

% Case 0: alpha == 1.0, beta = 0.0, zero base, no transpose,
% column-major


% read the matrix generated by the C program

C0File = fopen(C0FileName, 'r');
M0 = fscanf(C0File,'%d',1);
N0 = fscanf(C0File,'%d',1);
origC0 = fscanf(C0File,'%f',[30,30]);
C0 = origC0';
alpha = 1.0;
beta = 0.0;
C = alpha * A * B;

disp('Case 0:')
disp('C')
disp(C)
disp('C0')
disp(C0)
disp('norm(C-C0)')
disp(norm(C-C0)/((norm(C) + norm(C0)/2)))

% **************************** Case 2

% Case 2:  alpha == 0.0 && beta != 0.0


% read the matrix generated by the C program
C2File = fopen(C2FileName,'r');
fscanf(C2File,'%d',1);
fscanf(C2File,'%d',1);
origC2 = fscanf(C2File,'%f',[30,30]);
C2 = origC2';
alpha = 0.0;
beta = -3.75;

origC = [ones(30,30)];
C = alpha * A * B + beta * origC;

disp('Case 2:')
%disp('C')
%disp(C)
%disp('C2')
%disp(C2)
disp('norm(C-C2)')
disp(norm(C-C2)/((norm(C) + norm(C2)/2)))



% **************************** Case 3

% Case 3:	transpose


% read the matrix generated by the C program
C3File = fopen(C3FileName,'r');
fscanf(C3File,'%d',1);
fscanf(C3File,'%d',1);
origC3 = fscanf(C3File,'%f',[30,30]);
C3 = origC3';

alpha = 1.0;
beta = 0.0;

C = alpha * A' * B;

disp('Case 3:')
%disp('C')
%disp(C)
%disp('C3')
%disp(C3)
disp('norm(C-C3)')
disp(norm(C-C3)/((norm(C) + norm(C3)/2)))


% ***************** Case 8 & Case 10

% Case 8 and Case 10:	RowMajor && beta == 0.0 && alpha == 1.0


% read the matrix generated by the C program
C8File = fopen(C8FileName,'r');
fscanf(C8File,'%d',1);
fscanf(C8File,'%d',1);
origC8 = fscanf(C8File,'%f',[30,30]);
C8 = origC8';

alpha = 1.0;
beta = 0.0;

C = alpha * A * Browmaj;

disp('Case 8 (& Case 10):')
%disp('C')
%disp(C)
%disp('C8')
%disp(C8)
disp('norm(C-C8)')
disp(norm(C-C8)/((norm(C) + norm(C8)/2)))


% ***************** Case 9 & Case 11

% Case 9 and Case 11:	RowMajor && beta != 0 && alpha != 1.0


% read the matrix generated by the C program
C9File = fopen(C9FileName,'r');
fscanf(C9File,'%d',1);
fscanf(C9File,'%d',1);
origC9 = fscanf(C9File,'%f',[30,30]);
C9 = origC9';

alpha = 2.25;
beta = -3.75;

origC = [ones(30,30)];
C = alpha * A * Browmaj + beta * origC;

disp('Case 9 (& Case 11):')
%disp('C')
%disp(C)
%disp('C9')
%disp(C9)
disp('norm(C-C9)')
disp(norm(C-C9)/((norm(C) + norm(C9)/2)))


% ***************** Case 13 ***********

% Case 13  Column major and B, C submatrices


% read the matrix generated by the C program
C13File = fopen(C13FileName,'r');
fscanf(C13File,'%d',1);
fscanf(C13File,'%d',1);
origC13 = fscanf(C13File,'%f',[30,30]);
C13 = origC13';

alpha = 1.0;
beta = 0.0;

% read our B13 matrix
B13File = fopen(B13FileName,'r');
fscanf(B13File,'%d',1);
fscanf(B13File,'%d',1);
B13 = fscanf(B13File,'%f',[30,30]);

% use B13 transpose, since it is used row-major in C
C = alpha * A * B13';

disp('Case 13:')
%disp('B')
%disp(B13)
%disp('C')
%disp(C)
%disp('C13')
%disp(C13)
disp('norm(C-C13)')
disp(norm(C-C13)/((norm(C) + norm(C13)/2)))




